function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/* eslint-disable react/jsx-no-constructed-context-values */
import styled, { css } from 'styled-components';
import { IconContext } from 'phosphor-react';
import React from 'react';
import { Spinner } from '../spinner';
import { cv } from '../../style';
const sizeMap = {
  small: css`
        height: 26px;
        padding: 0px 8px;
        width: ${props => props.width};
        ${props => props.iconOnly && !props.width && css`
                padding: 0;
                width: 26px;
            `}
    `,
  medium: css`
        height: 32px;
        padding: 0px 12px;
        width: ${props => props.width};
        ${props => props.iconOnly && !props.width && css`
                padding: 0;
                width: 32px;
            `}
    `,
  large: css`
        height: 40px;
        padding: 0px 16px;
        width: ${props => props.width};
        ${props => props.iconOnly && !props.width && css`
                padding: 0;
                width: 40px;
            `}
    `
};
const colorMap = {
  default: {
    gray: css`
            color: ${cv.text1};
            --local-color: ${cv.text1};
            background-color: ${cv.bg_element2};
            border: solid 1px ${cv.border2};

            &:hover {
                background-color: ${cv.bg_element3};
                --local-border: solid 1px ${cv.border1};
            }

            &:active {
                background-color: ${cv.bg_element4};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                border: solid 1px ${cv.border3};
                color: ${cv.border3};
                --local-color: ${cv.border3};
            }

            &:focus-visible::after {
                outline-color: ${cv.border2};
            }
        `,
    red: css`
            color: ${cv.red1};
            --local-color: ${cv.red1};
            background-color: ${cv.bg_red1};
            border: solid 1px ${cv.red1};

            &:hover {
                background-color: ${cv.bg_red1_hover};
            }

            &:active {
                background-color: ${cv.bg_red1_hover};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                border: solid 1px ${cv.bg_red1};
                color: ${cv.bg_red1};
                --local-color: ${cv.bg_red1};
            }

            &:focus-visible::after {
                outline-color: ${cv.red1};
            }
        `,
    blue: css`
            color: ${cv.blue1};
            --local-color: ${cv.blue1};
            background-color: ${cv.bg_blue1};
            border: solid 1px ${cv.blue1};

            &:hover {
                background-color: ${cv.bg_blue1_hover};
            }

            &:active {
                background-color: ${cv.bg_blue1_hover};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                border: solid 1px ${cv.bg_blue1};
                color: ${cv.bg_blue1};
                --local-color: ${cv.bg_blue1};
            }

            &:focus-visible::after {
                outline-color: ${cv.blue1};
            }
        `
  },
  contained: {
    gray: css`
            color: ${cv.bg_element1};
            // --local-color은 inherit으로 color를 받기 힘든 컴포넌트를 위한 CSS 변수입니다.
            // 스타일 추가시 color 속성을 사용하신다면 --local-color 속성도 추가해주셔야 합니다.
            // 현재는 isLoading 때 표시하는 Spinner의 색상 지정을 위해 사용중입니다.
            --local-color: ${cv.bg_element1};
            background-color: ${cv.bg_element5};
            border: solid 1px ${cv.bg_element5};

            &:hover {
                color: ${cv.bg_element5};
                --local-color: ${cv.bg_element5};
                background-color: ${cv.bg_element1};
            }

            &:active {
                background-color: ${cv.bg_element3};
            }

            &:disabled {
                background-color: ${cv.bg_element3};
                border: solid 1px ${cv.bg_element3};
                color: ${cv.bg_element1};
                --local-color: ${cv.bg_element1};
            }

            &:focus-visible::after {
                outline-color: ${cv.bg_element5};
            }
        `,
    red: css`
            color: ${cv.bg_element1};
            --local-color: ${cv.bg_element1};
            background-color: ${cv.red1};
            border: solid 1px ${cv.red1};

            &:hover {
                color: ${cv.red1};
                --local-color: ${cv.red1};
                background-color: ${cv.bg_element1};
            }

            &:active {
                background-color: ${cv.bg_element3};
            }

            &:disabled {
                background-color: ${cv.bg_red1};
                border: solid 1px ${cv.bg_red1};
                color: ${cv.bg_element1};
                --local-color: ${cv.bg_element1};
            }

            &:focus-visible::after {
                outline-color: ${cv.red1};
            }
        `,
    blue: css`
            color: ${cv.bg_element1};
            --local-color: ${cv.bg_element1};
            background-color: ${cv.blue1};
            border: solid 1px ${cv.blue1};

            &:hover {
                color: ${cv.blue1};
                --local-color: ${cv.blue1};
                background-color: ${cv.bg_element1};
            }

            &:active {
                background-color: ${cv.bg_element3};
            }

            &:disabled {
                background-color: ${cv.bg_blue1};
                border: solid 1px ${cv.bg_blue1};
                color: ${cv.bg_element1};
                --local-color: ${cv.bg_element1};
            }

            &:focus-visible::after {
                outline-color: ${cv.blue1};
            }
        `
  },
  outlined: {
    gray: css`
            color: ${cv.text1};
            --local-color: ${cv.text1};
            background-color: ${cv.bg_element1};
            border: solid 1px ${cv.border2};

            &:hover {
                background-color: ${cv.bg_element1};
                border: solid 1px ${cv.border1};
                --local-border: solid 1px ${cv.border1};
            }

            &:active {
                background-color: ${cv.bg_element2};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                border: solid 1px ${cv.border3};
                color: ${cv.border3};
                --local-color: ${cv.border3};
            }

            &:focus-visible::after {
                outline-color: ${cv.border2};
            }
        `,
    red: css`
            color: ${cv.red1};
            --local-color: ${cv.red1};
            background-color: ${cv.bg_red1};
            border: solid 1px ${cv.red1};

            &:hover {
                background-color: ${cv.bg_red1_hover};
            }

            &:active {
                background-color: ${cv.bg_red1_hover};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                border: solid 1px ${cv.bg_red1};
                color: ${cv.bg_red1};
                --local-color: ${cv.bg_red1};
            }

            &:focus-visible::after {
                outline-color: ${cv.red1};
            }
        `,
    blue: css`
            color: ${cv.blue1};
            --local-color: ${cv.blue1};
            background-color: ${cv.bg_blue1};
            border: solid 1px ${cv.blue1};

            &:hover {
                background-color: ${cv.bg_blue1_hover};
            }

            &:active {
                background-color: ${cv.bg_blue1_hover};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                border: solid 1px ${cv.bg_blue1};
                color: ${cv.bg_blue1};
                --local-color: ${cv.bg_blue1};
            }

            &:focus-visible::after {
                outline-color: ${cv.blue1};
            }
        `
  },
  text: {
    gray: css`
            color: ${cv.text1};
            --local-color: ${cv.text1};
            background-color: ${cv.bg_element1};
            border: solid 1px ${cv.bg_element1};

            &:hover {
                background-color: ${cv.bg_element2};
            }

            &:active {
                background-color: ${cv.bg_element3};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                color: ${cv.text3};
                --local-color: ${cv.text3};
            }

            &:focus-visible::after {
                outline-color: ${cv.text1};
            }
        `,
    red: css`
            color: ${cv.red1};
            --local-color: ${cv.red1};
            background-color: ${cv.bg_element1};
            border: solid 1px ${cv.bg_element1};

            &:hover {
                background-color: ${cv.bg_red1_hover};
            }

            &:active {
                background-color: ${cv.bg_red1_hover};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                color: ${cv.bg_red1};
                --local-color: ${cv.bg_red1};
            }

            &:focus-visible::after {
                outline-color: ${cv.red1};
            }
        `,
    blue: css`
            color: ${cv.blue1};
            --local-color: ${cv.blue1};
            background-color: ${cv.bg_element1};
            border: solid 1px ${cv.bg_element1};

            &:hover {
                background-color: ${cv.bg_blue1_hover};
            }

            &:active {
                background-color: ${cv.bg_blue1_hover};
            }

            &:disabled {
                background-color: ${cv.bg_element1};
                color: ${cv.bg_blue1};
                --local-color: ${cv.bg_blue1};
            }

            &:focus-visible::after {
                outline-color: ${cv.blue1};
            }
        `
  }
};
const StyledButton = styled.button`
    display: flex;
    justify-content: center;
    align-items: center;
    user-select: none;
    position: relative;
    font-size: 14px;
    border: 0;
    text-decoration: none;
    transition: 150ms;
    font-weight: 500;
    line-height: 20px;
    gap: 8px;
    cursor: pointer;
    border-radius: 4px;

    &::after {
        content: '';
        position: absolute;
        z-index: 1;
        top: 0px;
        right: 0px;
        bottom: 0px;
        left: 0px;
        transition: 200ms;
        display: block;
        pointer-events: none;
        border-radius: 4px;
        outline: solid 2px transparent;
    }

    &:focus-visible {
        outline: none;
        transition: 200ms;

        &::after {
            top: -3px;
            right: -3px;
            bottom: -3px;
            left: -3px;
        }
    }

    &:disabled {
        cursor: not-allowed;
    }

    ${props => sizeMap[props.size]};
    ${props => colorMap[props.variant][props.color]};
`;

/**
 * 버튼
 */
export const Button = /*#__PURE__*/React.forwardRef(({
  children,
  variant = 'default',
  isLoading = false,
  color = 'gray',
  size = 'medium',
  icon,
  iconPosition = 'start',
  onClick,
  type = 'button',
  width,
  disabled = false,
  as,
  asProps = {},
  ...props
}, ref) => {
  // 아이콘
  let Icon;

  if (typeof icon === 'string') {
    Icon = /*#__PURE__*/React.createElement("img", {
      src: icon,
      alt: ""
    });
  }

  const buttonChildren = /*#__PURE__*/React.createElement(IconContext.Provider, {
    value: {
      size: 16,
      weight: 'bold'
    }
  }, isLoading && /*#__PURE__*/React.createElement(Spinner, {
    size: 16,
    color: "var(--local-color)"
  }), !isLoading && iconPosition === 'start' && (Icon || icon), !isLoading && children, !isLoading && iconPosition === 'end' && (Icon || icon));
  return /*#__PURE__*/React.createElement(StyledButton, _extends({}, asProps, props, {
    ref: ref,
    width: width,
    onClick: () => onClick && onClick(),
    color: color,
    size: size,
    variant: variant,
    type: type,
    as: as,
    disabled: disabled,
    iconOnly: !children && icon
  }), buttonChildren);
});