function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import styled from 'styled-components';
import React from 'react';
import { CaretRight } from 'phosphor-react';
import { Link } from '..';
import { cv } from '../../style';
const ItemTitle = styled.div`
    font-size: 14px;
    margin-bottom: 4px;
    color: ${cv.text1};
`;
const StyledTitleLink = styled(Link)`
    font-size: 14px;
    margin-bottom: 4px;
    display: flex;
    align-items: center;
`;
const StyledLink = styled(Link)`
    font-size: 14px;
`;

function TitleLink(props) {
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(StyledTitleLink, _extends({}, props, {
    showUnderline: false,
    color: cv.text1
  }), props.children, /*#__PURE__*/React.createElement(CaretRight, {
    size: 14,
    color: cv.text1,
    style: {
      marginBottom: '-2px'
    }
  })));
}

function ItemLink(props) {
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(StyledLink, _extends({}, props, {
    showUnderline: false,
    color: cv.text3
  })));
}

const Item = styled.div`
    display: flex;
    flex-direction: column;
    gap: 8px;
    flex: 1;
    width: 100%;
`;
const StyledFooterNavigation = styled.div`
    display: flex;
    justify-content: space-between;
    gap: 8px;

    @media (max-width: 767px) {
        column-gap: 12px;
        row-gap: 48px;
        display: grid;
        grid-template-columns: 1fr 1fr;
        text-align: center;

        ${Item} {
            align-items: center;
        }
    }
`;
export const FooterNavigation = Object.assign(StyledFooterNavigation, {
  Item: Object.assign(Item, {
    Title: ItemTitle,
    TitleLink,
    Link: ItemLink
  })
});