function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import styled, { css } from 'styled-components';
import { cv } from '../../style';
import { Label } from './label';
import { Flex } from '..';
const CheckBoxDiv = styled.div`
    display: flex;
    align-items: center;
    gap: 8px;
`;
const Input = styled.input`
    appearance: none;

    width: 22px;
    height: 22px;
    border-radius: 4px;
    border: solid 1px ${props => props.borderColor};
    background: ${props => props.backgroundColor};
    display: flex;
    align-items: center;
    justify-content: center;
    transition: 200ms;

    cursor: ${props => props.disabled ? 'not-allowed' : 'pointer'};

    &:hover {
        border: solid 1px ${props => props.borderColorHover};
    }

    &:checked {
        border-color: transparent;
        background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' stroke='white' stroke-width='2' viewBox='0 0 24 24'%3E%3Cpolyline points='19 7 10 17 5 12' /%3E%3C/svg%3E");
        background-size: 100% 100%;
        background-position: 50%;
        background-repeat: no-repeat;
        background-color: ${cv.bg_element5};
    }
`;
const Text = styled.div`
    display: block;
    font-size: 14px;

    ${props => props.required && css`
            ::after {
                content: ' *';
            }
        `}
`;
export const Checkbox = /*#__PURE__*/React.forwardRef((props, ref) => {
  const style = {
    backgroundColor: '',
    backgroundColorHover: '',
    borderColor: '',
    borderColorHover: ''
  };

  if (props.checked) {
    if (props.disabled) {
      style.backgroundColor = cv.bg_element6;
      style.backgroundColorHover = cv.bg_element6;
      style.borderColor = cv.bg_element6;
      style.borderColorHover = cv.bg_element6;
    } else {
      style.backgroundColor = cv.bg_element5;
      style.backgroundColorHover = cv.bg_element5;
      style.borderColor = cv.bg_element5;
      style.borderColorHover = cv.bg_element5;
    }
  } else if (props.disabled) {
    style.borderColor = cv.border3;
    style.borderColorHover = cv.border3;
  } else {
    style.borderColor = cv.border3;
    style.borderColorHover = cv.border3;
  }

  return /*#__PURE__*/React.createElement(Flex, {
    style: {
      flexDirection: 'column'
    }
  }, props.label && /*#__PURE__*/React.createElement(Label, {
    required: props.required || false
  }, props.label), /*#__PURE__*/React.createElement(CheckBoxDiv, null, /*#__PURE__*/React.createElement(Input, _extends({
    type: "checkbox"
  }, style, props, {
    ref: ref
  })), /*#__PURE__*/React.createElement(Text, {
    required: props.required || false
  }, props.text)));
});