import React from 'react';
declare type ButtonAddon = {
    type: 'button';
    label?: string;
    icon?: React.ReactElement;
    onClick: () => void;
};
export declare type TextFieldProps = React.ComponentPropsWithoutRef<'input'> & {
    label?: React.ReactNode;
    type?: 'text' | 'password' | 'search' | 'url' | 'email' | 'number' | 'tel';
    error?: React.ReactNode;
    leftAddon?: React.ReactNode | ButtonAddon;
    rightAddon?: React.ReactNode | ButtonAddon;
    border?: 'all' | 'bottom' | 'none';
};
export declare const TextField: React.ForwardRefExoticComponent<Pick<React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>, "key" | keyof React.InputHTMLAttributes<HTMLInputElement>> & {
    label?: React.ReactNode;
    type?: "number" | "text" | "search" | "tel" | "url" | "email" | "password" | undefined;
    error?: React.ReactNode;
    leftAddon?: React.ReactNode | ButtonAddon;
    rightAddon?: React.ReactNode | ButtonAddon;
    border?: "none" | "bottom" | "all" | undefined;
} & React.RefAttributes<HTMLInputElement>>;
export {};
