function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/* eslint-disable react/prop-types */

/* eslint-disable react/jsx-no-constructed-context-values */

/* eslint-disable no-nested-ternary */
import styled, { css } from 'styled-components';
import { IconContext } from 'phosphor-react';
import React from 'react';
import { cv } from '../../style';
import { Label } from './label';
const Divver = styled.div`
    width: 100%;
`;
const Input = styled.input`
    z-index: 1;
    padding: 0px 12px;
    height: 32px;
    display: flex;
    align-items: center;
    transition: 200ms;
    flex: 1;
    box-sizing: content-box;
    border: 0;
    font-size: 14px;
    outline: solid 3px rgba(0, 0, 0, 0);
    box-shadow: 0px 0px 3px transparent;

    ${props => props.border === 'all' ? css`
                  border-radius: 2px;
              ` : props.border === 'bottom' ? css`` : ''}

    &:focus {
        ${props => props.border === 'all' ? css`
                      outline: solid 3px ${cv.outline};
                  ` : props.border === 'bottom' ? css`
                      box-shadow: 0px 3px 0px ${cv.outline};
                  ` : ''}
    }
`;
const Message = styled.div`
    height: 20px;
    color: ${cv.red1};
    font-size: 14px;
    margin-top: 4px;
`;
const Inputs = styled.div`
    display: flex;
    align-items: center;
    height: 36px;
    ${props => props.border === 'all' ? css`
                  border-radius: 4px;
                  border: solid 1px ${cv.border3};
              ` : props.border === 'bottom' ? css`
                  border-bottom: solid 1px ${cv.border3};
              ` : ''}
`;
const AddonTextDiv = styled.div`
    padding: 0px 12px;
    display: flex;
    align-items: center;
    height: 100%;
    font-size: 14px;
    background-color: ${cv.bg_element3};

    ${props => props.position === 'left' ? `border-right: solid 1px ${cv.border3};` : `border-left: solid 1px ${cv.border3};`};
    ${props => props.position === 'left' ? `border-bottom-left-radius: 4px; border-top-left-radius: 4px;` : 'border-bottom-right-radius: 4px; border-top-right-radius: 4px;'};
`;
const AddonButtonDiv = styled.div`
    padding: 0px 8px;
    display: flex;
    align-items: center;
    height: 100%;
    font-size: 14px;
    background-color: ${cv.bg_element5};
    color: #ffffff;
    cursor: pointer;

    ${props => props.position === 'left' ? `border-right: solid 1px ${cv.border3};` : `border-left: solid 1px ${cv.border3};`};
    ${props => props.position === 'left' ? `border-bottom-left-radius: 4px; border-top-left-radius: 4px;` : 'border-bottom-right-radius: 4px; border-top-right-radius: 4px;'};
`;

function Addon({
  position,
  data
}) {
  if (typeof data === 'string') {
    return /*#__PURE__*/React.createElement(AddonTextDiv, {
      position: position
    }, data);
  }

  if (data.type === 'button') {
    return /*#__PURE__*/React.createElement(AddonButtonDiv, {
      position: position,
      onClick: () => data.onClick()
    }, data.icon, data.label);
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null);
}

export const TextField = /*#__PURE__*/React.forwardRef((props, ref) => {
  return /*#__PURE__*/React.createElement(IconContext.Provider, {
    value: {
      weight: 'bold',
      size: 14,
      color: cv.text5
    }
  }, /*#__PURE__*/React.createElement(Divver, null, props.label && /*#__PURE__*/React.createElement(Label, {
    required: props.required || false
  }, props.label), /*#__PURE__*/React.createElement(Inputs, {
    border: props.border || 'all'
  }, props.leftAddon && /*#__PURE__*/React.createElement(Addon, {
    position: "left",
    data: props.leftAddon
  }), /*#__PURE__*/React.createElement(Input, _extends({}, props, {
    value: props.value,
    ref: ref,
    type: props.type || 'text',
    border: props.border || 'all'
  })), props.rightAddon && /*#__PURE__*/React.createElement(Addon, {
    position: "right",
    data: props.rightAddon
  })), props.error && /*#__PURE__*/React.createElement(Message, null, props.error)));
});